## sslh 1.6i

=== Makefile ===
# Configuration

VERSION="v1.6i"
USELIBWRAP=1	# Use libwrap?
PREFIX=/usr/local

MAN=sslh.8.gz	# man page name

# End of configuration -- the rest should take care of
# itself

CC = gcc
CFLAGS=-Wall

#LIBS=-lnet
LIBS=

ifneq ($(strip $(USELIBWRAP)),)
	LIBS:=$(LIBS) -lwrap
	CFLAGS:=$(CFLAGS) -DLIBWRAP
endif

all: sslh $(MAN)

sslh: sslh.c Makefile
	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh sslh.c $(LIBS)
	strip sslh

$(MAN): sslh.pod Makefile
	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)

# generic install: install binary and man page
install: sslh $(MAN)
	install -D sslh $(PREFIX)/sbin/sslh
	install -D -m 0644 $(MAN) $(PREFIX)/share/man/man8/$(MAN)

# "extended" install for Debian: install startup script
install-debian: install sslh $(MAN)
	sed -e "s+^PREFIX=+PREFIX=$(PREFIX)+" scripts/etc.init.d.sslh > /etc/init.d/sslh
	chmod 755 /etc/init.d/sslh
	cp scripts/etc.default.sslh /etc/default/sslh
	update-rc.d sslh defaults

uninstall:
	rm -f $(PREFIX)/sbin/sslh $(PREFIX)/share/man/man8/$(MAN) /etc/init.d/sslh /etc/default/sslh
	update-rc.d sslh remove

clean:
	rm -f sslh $(MAN)

## sslh 1.7a

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Configuration
 
-VERSION="v1.6i"
+VERSION="v1.7a"
 USELIBWRAP=1	# Use libwrap?
 PREFIX=/usr/local

=== debian/changelog ===
sslh (1.7a-3) unstable; urgency=low

  * Debconf translation:
    + Add es.po, thanks Camaléon (Closes: #600181)
    + Add vi.po, thanks Clytie Siddall (Closes: #598591)
  * debian/init: Change /etc/inetd.conf test (Closes: #603608)
  * debian/portrm: Test update-inetd and deluser presence before using it
    (piuparts removal error)

 -- Guillaume Delacour <gui@iroqwa.org>  Tue, 02 Nov 2010 21:44:49 +0100

sslh (1.7a-2) unstable; urgency=low

  * Change DAEMON_ARGS to DAEMON_OPTS in initscript to match /etc/default/sslh
    variable (Closes: #596199)
  * Modify initscript to return 2 and not exit if RUN=no (Closes: #596111)

 -- Guillaume Delacour <gui@iroqwa.org>  Thu, 09 Sep 2010 22:27:04 +0200

sslh (1.7a-1) unstable; urgency=low

  * New upstream release (Closes: #563156)
    + Provide inetd support (thanks Dima Barsky)
  * Provide debconf to standalone/inetd mode selection
    + Add fr.po, thanks David Prévot for proofreadig
    + Add it.po, thanks Vincenzo Campanella
    + Add sv.po, thanks Martin Bagge            (Closes: #593673)
    + Add ru.po, thanks Yuri Kozlov             (Closes: #593766)
    + Add de.po, thanks Chris Leick             (Closes: #594019)
    + Add pt.po, thanks Rui Branco              (Closes: #594124)
    + Add da.po, thanks Joe Dalton              (Closes: #594212)
    + Add cs.po, thanks Michal Simunek          (Closes: #594508)
    + Add pt_BR.po, thanks Adriano Rafael Gomes (Closes: #594751)
  * debian/logcheck.ignore.server: Provide logcheck ignore rule
    (Closes: #565858, thanks Craig Small)
  * debian/init: New initscript (based on /etc/init.d/skeleton):
    + Depend on $remote_fs, $syslog and $network in Required-{Start,Stop}
    + Test inetd mode, to not start in standalone
  * debian/default:
    + Delete option "-P /var/run/sslh.pid" (default value)
    + Add "RUN=no" to easy turn on
  * Bump to Standards-Version 3.9.1 (no changes needed)
  * debian/control:
    + Depends on ${misc:Depends}, update-inetd, lsb-base
      and suggest openbsd-inetd | inet-superserver
    + Increase debhelper dependency to 7.0.50~
    + Build depends on po-debconf for templates
  * Switch to dpkg-source 3.0 (quilt) format
  * debian/manpages: Add sslh.8.gz (dh_installman)
  * debian/rules: Rewrite based on more simple dh_make 0.55 template
  * debian/postrm: Delete sslh user in purge case only
  * debian/post{inst,rm}: Delete unneccessary case
  * debian/patches/01_option_user_manpage_error.diff:
    Fix little typo in manpage, reported upstream

 -- Guillaume Delacour <gui@iroqwa.org>  Mon, 26 Jul 2010 23:40:01 +0200

sslh (1.6i-4) unstable; urgency=low

  * debian/control:
    Recommends apache2 and openssh-server instead of depends on them.
    Also recommend ssh-server as a virtual alternative (Closes: #559343).

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 06 Dec 2009 16:02:39 +0100

sslh (1.6i-3) unstable; urgency=low

  * debian/control: Conflicts with libnet-proxy-perl (Closes: #550997).
  * Bump to Standards-Version 3.8.3 (no changes needed).

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 14 Oct 2009 19:32:23 +0000

sslh (1.6i-2) unstable; urgency=low

  * Bump to Standards-Version 3.8.2 (no changes needed).

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 15 Jul 2009 00:00:43 +0000

sslh (1.6i-1) unstable; urgency=low

  * New upstream release
   - Fix MAX_PATH (static allocation instead)
   - Fix openlog call
  * Bump to Standards-Version 3.8.1 (no changes needed).

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 26 Apr 2009 12:13:15 +0000

sslh (1.6h-1) unstable; urgency=low

  * New upstream release
    - Fix zombies process after a while (to finish process cleanly)

 -- Guillaume Delacour <gui@iroqwa.org>  Sat, 25 Apr 2009 15:32:18 +0200

sslh (1.6g-3) unstable; urgency=low

  * Fix postinstall printed message:
   /etc/default/ssh to /etc/default/sslh in postinst

 -- Guillaume Delacour <gui@iroqwa.org>  Fri, 27 Feb 2009 14:49:57 +0100

sslh (1.6g-2) unstable; urgency=low

  * Fix some typos in README.Debian (thanks to the author)

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 04 Feb 2009 19:18:12 +0100

sslh (1.6g-1) unstable; urgency=low

  * Initial release (Closes: #497095)

 -- Guillaume Delacour <gui@iroqwa.org>  Fri, 17 Jan 2009 16:23:51 +0100

=== debian/control ===
Source: sslh
Section: net
Priority: extra
Maintainer: Guillaume Delacour <gui@iroqwa.org>
Build-Depends: debhelper (>= 7.0.50~), libwrap0-dev, binutils, po-debconf
Standards-Version: 3.9.1
Homepage: http://www.rutschle.net/tech/sslh.shtml

Package: sslh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, debconf (>= 0.5), lsb-base (>= 3.0-6), update-inetd
Recommends: apache2 | httpd, openssh-server | ssh-server
Suggests: openbsd-inetd | inet-superserver
Conflicts: libnet-proxy-perl
Description: ssl/ssh multiplexer
 sslh lets one accept both HTTPS and SSH connections on the
 same port. It makes it possible to connect to an SSH server
 on port 443 (e.g. from inside a corporate firewall) while
 still serving HTTPS on that port.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Warning: PREFIX instead of DESTDIR in upstream Makefile
override_dh_auto_install:
	dh_auto_install -- PREFIX=debian/sslh/usr install

# do not start daemon by default: force user to configure
override_dh_installinit:
	dh_installinit --no-start

%:
	dh $@

=== debian/watch ===
version=3
http://www.rutschle.net/tech/sslh-(.*)\.tar\.gz

## sslh 1.9

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Configuration
 
-VERSION="v1.7a"
-USELIBWRAP=1	# Use libwrap?
+VERSION="v1.9"
+USELIBWRAP=	# Use libwrap?
 PREFIX=/usr/local
 
 MAN=sslh.8.gz	# man page name
@@ -10,10 +10,11 @@
 # itself
 
 CC = gcc
-CFLAGS=-Wall
+CFLAGS=-Wall -g
 
 #LIBS=-lnet
 LIBS=
+OBJS=common.o
 
 ifneq ($(strip $(USELIBWRAP)),)
 	LIBS:=$(LIBS) -lwrap
@@ -22,16 +23,27 @@
 
 all: sslh $(MAN)
 
-sslh: sslh.c Makefile
-	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh sslh.c $(LIBS)
-	strip sslh
+.c.o: *.h
+	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -c $<
+
+
+sslh: $(OBJS) sslh-fork sslh-select
+
+sslh-fork: $(OBJS) sslh-fork.o Makefile common.h
+	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh-fork sslh-fork.o $(OBJS) $(LIBS)
+	strip sslh-fork
+
+sslh-select: $(OBJS) sslh-select.o Makefile common.h 
+	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh-select sslh-select.o $(OBJS) $(LIBS)
+	strip sslh-select
+
 
 $(MAN): sslh.pod Makefile
 	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)
 
 # generic install: install binary and man page
 install: sslh $(MAN)
-	install -D sslh $(PREFIX)/sbin/sslh
+	install -D sslh-fork $(PREFIX)/sbin/sslh
 	install -D -m 0644 $(MAN) $(PREFIX)/share/man/man8/$(MAN)
 
 # "extended" install for Debian: install startup script
@@ -46,4 +58,11 @@
 	update-rc.d sslh remove
 
 clean:
-	rm -f sslh $(MAN)
+	rm -f sslh-fork sslh-select $(MAN) *.o
+
+tags:
+	ctags -T *.[ch]
+
+test:
+	./t
+

=== debian/changelog ===
sslh (1.9-1) unstable; urgency=low

  * New upstream release (Closes: #632834, #611611)
  * Drop debian/patches/01_option_user_manpage_error.diff, fixed upstream
  * Debconf translation: Add ja.po, thanks Hideki Yamane (Closes: #628461)
  * debian/control:
    + Newline after 80 chars in Depends
    + Add Vcs-{Browser,Git}, point to collab-maint
  * Bump to Standards-Version 3.9.2 (no changes needed)
  * debian/install: install new sslh-select binary
  * debian/links: provide manpage for new sslh-select binary (same as sslh)
  * debian/init:
    + Remove VERBOSE test to always print message
    + Remove DAEMON variable, used in /etc/default/sslh to choose binary
    + Move "is binary executable" test after sourcing /etc/default/sslh
  * debian/default:
    + DAEMON to choose sslh binary (fork or new single thread)
    + Use long options and change ss{l,h} options (upstream change)
  * debian/NEWS: document that a new binary sslh-select is provided
  * debian/copyright: Update to dep5 format
  * debian/logcheck.ignore.server: Update rule
    (upstream changes of logformat and IPv6 support)

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 14 Aug 2011 15:34:03 +0200

=== debian/control ===
--- 
+++ 
@@ -3,12 +3,15 @@
 Priority: extra
 Maintainer: Guillaume Delacour <gui@iroqwa.org>
 Build-Depends: debhelper (>= 7.0.50~), libwrap0-dev, binutils, po-debconf
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Homepage: http://www.rutschle.net/tech/sslh.shtml
+Vcs-Browser: http://git.debian.org/?p=collab-maint/sslh.git
+Vcs-Git: git://git.debian.org/collab-maint/sslh.git
 
 Package: sslh
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, debconf (>= 0.5), lsb-base (>= 3.0-6), update-inetd
+Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, debconf (>= 0.5),
+         lsb-base (>= 3.0-6), update-inetd
 Recommends: apache2 | httpd, openssh-server | ssh-server
 Suggests: openbsd-inetd | inet-superserver
 Conflicts: libnet-proxy-perl

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Warning: PREFIX instead of DESTDIR in upstream Makefile
override_dh_auto_install:
	# auto install fork version, see debian/install for select version
	dh_auto_install -- PREFIX=$(CURDIR)/debian/sslh/usr install

# do not start daemon by default: force user to configure
override_dh_installinit:
	dh_installinit --no-start

%:
	dh $@

## sslh 1.10

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,8 @@
 # Configuration
 
-VERSION="v1.9"
+VERSION="v1.10"
 USELIBWRAP=	# Use libwrap?
+COV_TEST= 	# Perform test coverage?
 PREFIX=/usr/local
 
 MAN=sslh.8.gz	# man page name
@@ -9,19 +10,23 @@
 # End of configuration -- the rest should take care of
 # itself
 
+ifneq ($(strip $(COV_TEST)),)
+    CFLAGS_COV=-fprofile-arcs -ftest-coverage
+endif
+
 CC = gcc
-CFLAGS=-Wall -g
+CFLAGS=-Wall -g $(CFLAGS_COV)
 
 #LIBS=-lnet
 LIBS=
-OBJS=common.o
+OBJS=common.o sslh-main.o
 
 ifneq ($(strip $(USELIBWRAP)),)
 	LIBS:=$(LIBS) -lwrap
 	CFLAGS:=$(CFLAGS) -DLIBWRAP
 endif
 
-all: sslh $(MAN)
+all: sslh $(MAN) echosrv
 
 .c.o: *.h
 	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -c $<
@@ -31,12 +36,14 @@
 
 sslh-fork: $(OBJS) sslh-fork.o Makefile common.h
 	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh-fork sslh-fork.o $(OBJS) $(LIBS)
-	strip sslh-fork
+	#strip sslh-fork
 
 sslh-select: $(OBJS) sslh-select.o Makefile common.h 
 	$(CC) $(CFLAGS) -D'VERSION=$(VERSION)' -o sslh-select sslh-select.o $(OBJS) $(LIBS)
-	strip sslh-select
+	#strip sslh-select
 
+echosrv: $(OBJS) echosrv.o
+	$(CC) $(CFLAGS) -o echosrv echosrv.o common.o $(LIBS)
 
 $(MAN): sslh.pod Makefile
 	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)
@@ -58,7 +65,7 @@
 	update-rc.d sslh remove
 
 clean:
-	rm -f sslh-fork sslh-select $(MAN) *.o
+	rm -f sslh-fork sslh-select echosrv $(MAN) *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info 
 
 tags:
 	ctags -T *.[ch]

=== debian/changelog ===
sslh (1.10-3) unstable; urgency=low

  * Refresh and rename debian/patch/ftbfs_ip6-localhost.diff to
    debian/patch/ftbfs_localhost.diff as the problem concern IPv4 localhost too
  * debian/control: use debhelper 9
  * debian/compat: Bump to version 9

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 07 Mar 2012 02:16:19 +0100

sslh (1.10-2) unstable; urgency=low

  * debian/patch/ftbfs_ip6-localhost.diff: Fix FTBFS if ip6-localhost don't
    resolv to ::1 (Closes: #660269)
  * debian/copyright: Update Format to 1.0
  * debian/control: Bump to Standards-Version 3.9.3 (no changes needed)

 -- Guillaume Delacour <gui@iroqwa.org>  Fri, 02 Mar 2012 23:45:07 +0100

sslh (1.10-1) unstable; urgency=low

  * New upstream release
  * debian/rules: Use hardening build options (DEB_BUILD_HARDENING)
  * debian/compat: Bump to version 8
  * debian/control:
    + Build-Depends on:
      - debhelper >= 8.0.0
      - hardening-wrapper
      - libio-socket-inet6-perl (upstream test suite use it)
    + Update Description with last info in upstream homepage
  * debian/copyright: Change URI to a versioned one
  * debian/init: Create /var/run/sslh because sslh now create pid as sslh user
  * debian/default: Set --pidfile to /var/run/sslh/sslh.pid
  * debian/patches/pidfile_long_option.diff: Fix typo in manpage about pid file
    (long option is --pidfile not --pid-file)

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 14 Dec 2011 20:59:14 +0100

=== debian/control ===
Source: sslh
Section: net
Priority: extra
Maintainer: Guillaume Delacour <gui@iroqwa.org>
Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
               hardening-wrapper, libio-socket-inet6-perl
Standards-Version: 3.9.3
Homepage: http://www.rutschle.net/tech/sslh.shtml
Vcs-Browser: http://git.debian.org/?p=collab-maint/sslh.git
Vcs-Git: git://git.debian.org/collab-maint/sslh.git

Package: sslh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, debconf (>= 0.5),
         lsb-base (>= 3.0-6), update-inetd
Recommends: apache2 | httpd, openssh-server | ssh-server
Suggests: openbsd-inetd | inet-superserver
Conflicts: libnet-proxy-perl
Description: ssl/ssh multiplexer
 sslh lets one accept HTTPS, SSH, OpenVPN, tinc and XMPP connections on the
 same port. This makes it possible to connect to any of these servers on
 port 443 (e.g. from inside a corporate firewall, which almost never block
 port 443) while still serving HTTPS on that port.

## sslh 1.13b

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 # Configuration
 
-VERSION="v1.10"
+VERSION="v1.13b"
+USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
 USELIBWRAP=	# Use libwrap?
 COV_TEST= 	# Perform test coverage?
 PREFIX=/usr/local
@@ -17,13 +18,17 @@
 CC = gcc
 CFLAGS=-Wall -g $(CFLAGS_COV)
 
-#LIBS=-lnet
 LIBS=
-OBJS=common.o sslh-main.o
+OBJS=common.o sslh-main.o probe.o
 
 ifneq ($(strip $(USELIBWRAP)),)
 	LIBS:=$(LIBS) -lwrap
 	CFLAGS:=$(CFLAGS) -DLIBWRAP
+endif
+
+ifneq ($(strip $(USELIBCONFIG)),)
+	LIBS:=$(LIBS) -lconfig
+	CFLAGS:=$(CFLAGS) -DLIBCONFIG
 endif
 
 all: sslh $(MAN) echosrv
@@ -68,7 +73,7 @@
 	rm -f sslh-fork sslh-select echosrv $(MAN) *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info 
 
 tags:
-	ctags -T *.[ch]
+	ctags --globals -T *.[ch]
 
 test:
 	./t

=== debian/changelog ===
sslh (1.13b-3.2) unstable; urgency=low

  * Non-maintainer upload.
  * Restore debian/patch/ftbfs_localhost.diff, as autobuilders are still not
    all fixed (Closes: #685928)

 -- David Prévot <taffit@debian.org>  Sun, 26 Aug 2012 11:35:48 -0400

sslh (1.13b-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * debian/control: Build-Depends on lcov, which contains lcov and genhtml
    that are used by upstream in the test suite code "t" (Closes: #684846)

 -- David Prévot <taffit@debian.org>  Thu, 23 Aug 2012 17:40:55 -0400

sslh (1.13b-3) unstable; urgency=low

  * debian/control: Build-Depends on psmisc, which contains killall and is
    used by upstream in the test suite code "t" (Closes: #678333)

 -- Guillaume Delacour <gui@iroqwa.org>  Thu, 21 Jun 2012 12:03:10 +0200

sslh (1.13b-2) unstable; urgency=low

  * debian/control, Build-Depends on virtual package libconfig-dev
    instead of transitional package libconfig8-dev (Closes: #678301)

 -- Guillaume Delacour <gui@iroqwa.org>  Wed, 20 Jun 2012 21:29:24 +0200

sslh (1.13b-1) unstable; urgency=low

  * New upstream release
  * debian/control: Add Build-Depend on libconfig8-dev
  * Drop debian/patches/pidfile_long_option.diff, fixed upstream
  * Drop debian/patch/ftbfs_localhost.diff, as autobuilders are fixed now
  * debian/patches/minor_typo_manpage.diff: Fix minor typo in manpage
  * debian/examples: sslh can now handle a protocol config file; provide
    upstream example.cfg as sample
  * debian/lintian-overrides: sslh doesn't use hardening fortified
    libc functions

 -- Guillaume Delacour <gui@iroqwa.org>  Fri, 25 May 2012 18:39:03 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,8 @@
 Priority: extra
 Maintainer: Guillaume Delacour <gui@iroqwa.org>
 Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
-               hardening-wrapper, libio-socket-inet6-perl
+               hardening-wrapper, libio-socket-inet6-perl, libconfig-dev,
+               psmisc, lcov
 Standards-Version: 3.9.3
 Homepage: http://www.rutschle.net/tech/sslh.shtml
 Vcs-Browser: http://git.debian.org/?p=collab-maint/sslh.git

=== debian/rules ===
--- 
+++ 
@@ -1,5 +1,8 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
+
+# hardening options at build time
+export DEB_BUILD_HARDENING=1
 
 # Warning: PREFIX instead of DESTDIR in upstream Makefile
 override_dh_auto_install:

=== debian/watch ===
version=3
opts="dversionmangle=s/~/-/" \
http://www.rutschle.net/tech/sslh-(.*)\.tar\.gz

## sslh 1.15

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # Configuration
 
-VERSION="v1.13b"
+VERSION="1.15"
 USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
 USELIBWRAP=	# Use libwrap?
 COV_TEST= 	# Perform test coverage?
@@ -15,10 +15,10 @@
     CFLAGS_COV=-fprofile-arcs -ftest-coverage
 endif
 
-CC = gcc
-CFLAGS=-Wall -g $(CFLAGS_COV)
+CC ?= gcc
+CFLAGS ?=-Wall -g $(CFLAGS_COV)
 
-LIBS=
+LIBS=$(LDFLAGS)
 OBJS=common.o sslh-main.o probe.o
 
 ifneq ($(strip $(USELIBWRAP)),)
@@ -48,10 +48,15 @@
 	#strip sslh-select
 
 echosrv: $(OBJS) echosrv.o
-	$(CC) $(CFLAGS) -o echosrv echosrv.o common.o $(LIBS)
+	$(CC) $(CFLAGS) -o echosrv echosrv.o probe.o common.o $(LIBS)
 
 $(MAN): sslh.pod Makefile
 	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)
+
+# Create release: export clean tree and tag current
+# configuration
+release:
+	git archive master --prefix="sslh-$(VERSION)/" | gzip > /tmp/sslh-$(VERSION).tar.gz
 
 # generic install: install binary and man page
 install: sslh $(MAN)

=== debian/changelog ===
sslh (1.15-1) unstable; urgency=medium

  * New upstream release (Closes: #720680)
  * Drop debian/patches/minor_typo_manpage.diff (no more needed)
  * debian/control: Point Vcs-{Browser,Git} to anonscm.debian.org
  * debian/lintian-overrides: Removed since sslh use fortified functions
  * debian/watch: update pattern from sepwatch
  * debian/default: change default 0.0.0.0 ip to <change-me> to force the
    user to properly set it, thanks Marc Haber (Closes: #720674)
  * debian/control: Bump to Standards-Version 3.9.5 (no changes needed)
  * debian/README.Debian: change configuration examples as sslh can now handle
    XMPP, OpenSSH and OpenVPN servers (Closes: #730098)
  * debian/logcheck.ignore.server: Update pattern, thanks Richard van den Berg
    (Closes: #705430)
  * debian/patches/disable_valgrind_launch.diff: Don't use valgrind in tests
  * Provide systemd support:
    + debian/sslh.service, based on upstream scripts/systemd.sslh.service
    + debian/rules: use "--with systemd" flag in debhelper generic call
    + debian/control: Build-Depends on dh-systemd

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 02 Feb 2014 12:57:32 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,11 @@
 Maintainer: Guillaume Delacour <gui@iroqwa.org>
 Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
                hardening-wrapper, libio-socket-inet6-perl, libconfig-dev,
-               psmisc, lcov
-Standards-Version: 3.9.3
+               psmisc, lcov, dh-systemd (>= 1.5)
+Standards-Version: 3.9.5
 Homepage: http://www.rutschle.net/tech/sslh.shtml
-Vcs-Browser: http://git.debian.org/?p=collab-maint/sslh.git
-Vcs-Git: git://git.debian.org/collab-maint/sslh.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sslh.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/sslh.git
 
 Package: sslh
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -14,4 +14,4 @@
 	dh_installinit --no-start
 
 %:
-	dh $@
+	dh $@ --with systemd

=== debian/watch ===
version=3
opts=uversionmangle=s/_/./g;s/^(\S*\.cyg-libconfig)$/0.0.$1/ \
http://www.rutschle.net/tech/sslh.shtml \
(?:|.*/)sslh(?:[_\-]v?|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## sslh 1.16

=== Makefile ===
# Configuration

VERSION=$(shell ./genver.sh -r)
USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
USELIBWRAP=	# Use libwrap?
USELIBCAP=	# Use libcap?
COV_TEST= 	# Perform test coverage?
PREFIX=/usr/local

MAN=sslh.8.gz	# man page name

# End of configuration -- the rest should take care of
# itself

ifneq ($(strip $(COV_TEST)),)
    CFLAGS_COV=-fprofile-arcs -ftest-coverage
endif

CC ?= gcc
CFLAGS ?=-Wall -g $(CFLAGS_COV)

LIBS=
OBJS=common.o sslh-main.o probe.o

ifneq ($(strip $(USELIBWRAP)),)
	LIBS:=$(LIBS) -lwrap
	CPPFLAGS+=-DLIBWRAP
endif

ifneq ($(strip $(USELIBCONFIG)),)
	LIBS:=$(LIBS) -lconfig
	CPPFLAGS+=-DLIBCONFIG
endif

ifneq ($(strip $(USELIBCAP)),)
	LIBS:=$(LIBS) -lcap
	CPPFLAGS+=-DLIBCAP
endif

all: sslh $(MAN) echosrv

.c.o: *.h
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $<

version.h:
	./genver.sh >version.h

sslh: sslh-fork sslh-select

sslh-fork: version.h $(OBJS) sslh-fork.o Makefile common.h
	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-fork sslh-fork.o $(OBJS) $(LIBS)
	#strip sslh-fork

sslh-select: version.h $(OBJS) sslh-select.o Makefile common.h
	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-select sslh-select.o $(OBJS) $(LIBS)
	#strip sslh-select

echosrv: $(OBJS) echosrv.o
	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o probe.o common.o $(LIBS)

$(MAN): sslh.pod Makefile
	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)

# Create release: export clean tree and tag current
# configuration
release:
	git archive master --prefix="sslh-$(VERSION)/" | gzip > /tmp/sslh-$(VERSION).tar.gz

# generic install: install binary and man page
install: sslh $(MAN)
	install -pD sslh-fork $(DESTDIR)$(PREFIX)/sbin/sslh
	install -pD -m 0644 $(MAN) $(DESTDIR)$(PREFIX)/share/man/man8/$(MAN)

# "extended" install for Debian: install startup script
install-debian: install sslh $(MAN)
	sed -e "s+^PREFIX=+PREFIX=$(PREFIX)+" scripts/etc.init.d.sslh > /etc/init.d/sslh
	chmod 755 /etc/init.d/sslh
	cp scripts/etc.default.sslh /etc/default/sslh
	update-rc.d sslh defaults

uninstall:
	rm -f $(DESTDIR)$(PREFIX)/sbin/sslh $(DESTDIR)$(PREFIX)/share/man/man8/$(MAN) $(DESTDIR)/etc/init.d/sslh $(DESTDIR)/etc/default/sslh
	update-rc.d sslh remove

distclean: clean
	rm -f tags cscope.*

clean:
	rm -f sslh-fork sslh-select echosrv version.h $(MAN) *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info

tags:
	ctags --globals -T *.[ch]

cscope:
	-find . -name "*.[chS]" >cscope.files
	-cscope -b -R

test:
	./t

=== debian/changelog ===
sslh (1.16-2) unstable; urgency=medium

  * Compile sslh with libcap support only on linux archs, thanks James Cowgill
    (Closes: #760055)

 -- Guillaume Delacour <gui@iroqwa.org>  Mon, 01 Sep 2014 20:36:48 +0200

sslh (1.16-1) unstable; urgency=medium

  * New upstream release: fix some startup problem when interfaces are not
    ready at boot time (IP_FREEBIND support when available) and can use libcap
    for transparent mode
  * Enable libcap and libwrap support at build time
  * Enable dpkg-buildflags: Drop hardening-wrapper Build-Depends and use
    DEB_BUILD_HARDENING instead of DEB_BUILD_MAINT_OPTIONS
  * Remove old .gitignore as upstream has one too
  * debian/sslh.tmpfile: Create /run/sslh for systemd as root because sslh
    write its pid before dropping privileges (Closes: #740560)
  * debian/patches/disable_ip_freebind_test.diff: Remove "Can't bind address"
    upstream test because IP_FREEBIND is now enabled upstream
  * debian/docs: upstream README is now README.md
  * debian/rules:
    + use DESTDIR in addition of PREFIX as upstream change Makefile
  * Refresh debian/patches/disable_valgrind_launch.diff due to upstream
    changes
  * Stop service in case of purge (to be able to remove the user too)
  * Use DEB_BUILD_OPTIONS to speed the build
  * debian/patches/fixed_version.diff: Fix the version of binaries based on
    debian/changelog (instead of relying on git)
  * Update Description as sslh is not only a ssl/ssh multiplexer but a
    protocol multiplexer

 -- Guillaume Delacour <gui@iroqwa.org>  Thu, 07 Aug 2014 00:06:06 +0200

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: extra
 Maintainer: Guillaume Delacour <gui@iroqwa.org>
 Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
-               hardening-wrapper, libio-socket-inet6-perl, libconfig-dev,
+               libio-socket-inet6-perl, libconfig-dev, libcap-dev [linux-any],
                psmisc, lcov, dh-systemd (>= 1.5)
 Standards-Version: 3.9.5
 Homepage: http://www.rutschle.net/tech/sslh.shtml
@@ -17,7 +17,7 @@
 Recommends: apache2 | httpd, openssh-server | ssh-server
 Suggests: openbsd-inetd | inet-superserver
 Conflicts: libnet-proxy-perl
-Description: ssl/ssh multiplexer
+Description: Applicative protocol multiplexer
  sslh lets one accept HTTPS, SSH, OpenVPN, tinc and XMPP connections on the
  same port. This makes it possible to connect to any of these servers on
  port 443 (e.g. from inside a corporate firewall, which almost never block

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# hardening options at build time
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
ifeq ($(DEB_HOST_ARCH_OS),linux)
	EXTRA_OPTIONS := USELIBCAP=1
else
	EXTRA_OPTIONS :=
endif

override_dh_auto_build:
	dh_auto_build --parallel -- USELIBWRAP=1 $(EXTRA_OPTIONS)

override_dh_auto_install:
	# auto install fork version, see debian/install for select version
	dh_auto_install -- DESTDIR=$(CURDIR)/debian/sslh/usr PREFIX=/ install

# do not start daemon by default: force user to configure
override_dh_installinit:
	dh_installinit --no-start

%:
	dh $@ --with systemd

## sslh 1.17

=== Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 VERSION=$(shell ./genver.sh -r)
 USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
-USELIBWRAP=	# Use libwrap?
+USELIBWRAP?=	# Use libwrap?
 USELIBCAP=	# Use libcap?
 COV_TEST= 	# Perform test coverage?
 PREFIX=/usr/local
@@ -75,7 +75,6 @@
 install-debian: install sslh $(MAN)
 	sed -e "s+^PREFIX=+PREFIX=$(PREFIX)+" scripts/etc.init.d.sslh > /etc/init.d/sslh
 	chmod 755 /etc/init.d/sslh
-	cp scripts/etc.default.sslh /etc/default/sslh
 	update-rc.d sslh defaults
 
 uninstall:

=== debian/changelog ===
sslh (1.17-2) unstable; urgency=medium

  * debian/postrm: Test execution of update-inetd and deluser binaries as they
    are Depends and might be unavailable when removing/pruging
    (Policy 7.2, Closes: #787508)

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 19 Jul 2015 15:37:28 +0000

sslh (1.17-1) unstable; urgency=medium

  * New upstream release
    + Document logging in /var/log/auth.log (Closes: #735922)
    + Do not require --listen when --inetd is specified (LP: #1382158)
    + disable_ip_freebind_test.diff merged
    + Refresh fixed_version.diff (and use dpkg-parsechangelog)
  * debian/watch: Update unrelated versions mangle regex
  * debian/control: Bump to Standards-Version 3.9.6 (no changes needed)
  * debian/postrm: Don't test binaries presence as already depends on packages
    providing them (lintian command-with-path-in-maintainer-script)
  * Debconf translation: Add nl.po: thanks Frans Spiesschaert (Closes: #766176)
  * Remove parallel building as the build may fail sometimes

 -- Guillaume Delacour <gui@iroqwa.org>  Sun, 31 May 2015 01:22:18 +0200

=== debian/control ===
--- 
+++ 
@@ -5,7 +5,7 @@
 Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
                libio-socket-inet6-perl, libconfig-dev, libcap-dev [linux-any],
                psmisc, lcov, dh-systemd (>= 1.5)
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://www.rutschle.net/tech/sslh.shtml
 Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sslh.git
 Vcs-Git: git://anonscm.debian.org/collab-maint/sslh.git

=== debian/rules ===
--- 
+++ 
@@ -3,11 +3,6 @@
 
 # hardening options at build time
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
-
-ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
-	MAKEFLAGS += -j$(NUMJOBS)
-endif
 
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 ifeq ($(DEB_HOST_ARCH_OS),linux)
@@ -17,7 +12,7 @@
 endif
 
 override_dh_auto_build:
-	dh_auto_build --parallel -- USELIBWRAP=1 $(EXTRA_OPTIONS)
+	dh_auto_build -- USELIBWRAP=1 $(EXTRA_OPTIONS)
 
 override_dh_auto_install:
 	# auto install fork version, see debian/install for select version

## sslh 1.18

=== Makefile ===
--- 
+++ 
@@ -1,11 +1,16 @@
 # Configuration
 
 VERSION=$(shell ./genver.sh -r)
+ENABLE_REGEX=1  # Enable regex probes
 USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
+USELIBPCRE=	# Use libpcre? (needed for regex on musl)
 USELIBWRAP?=	# Use libwrap?
 USELIBCAP=	# Use libcap?
+USESYSTEMD=     # Make use of systemd socket activation
 COV_TEST= 	# Perform test coverage?
-PREFIX=/usr/local
+PREFIX?=/usr
+BINDIR?=$(PREFIX)/sbin
+MANDIR?=$(PREFIX)/share/man/man8
 
 MAN=sslh.8.gz	# man page name
 
@@ -20,11 +25,20 @@
 CFLAGS ?=-Wall -g $(CFLAGS_COV)
 
 LIBS=
-OBJS=common.o sslh-main.o probe.o
+OBJS=common.o sslh-main.o probe.o tls.o
 
 ifneq ($(strip $(USELIBWRAP)),)
 	LIBS:=$(LIBS) -lwrap
 	CPPFLAGS+=-DLIBWRAP
+endif
+
+ifneq ($(strip $(ENABLE_REGEX)),)
+	CPPFLAGS+=-DENABLE_REGEX
+endif
+
+ifneq ($(strip $(USELIBPCRE)),)
+	CPPFLAGS+=-DLIBPCRE
+	LIBS:=$(LIBS) -lpcre
 endif
 
 ifneq ($(strip $(USELIBCONFIG)),)
@@ -36,6 +50,12 @@
 	LIBS:=$(LIBS) -lcap
 	CPPFLAGS+=-DLIBCAP
 endif
+
+ifneq ($(strip $(USESYSTEMD)),)
+        LIBS:=$(LIBS) -lsystemd
+        CPPFLAGS+=-DSYSTEMD
+endif
+
 
 all: sslh $(MAN) echosrv
 
@@ -55,8 +75,11 @@
 	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-select sslh-select.o $(OBJS) $(LIBS)
 	#strip sslh-select
 
+systemd-sslh-generator: systemd-sslh-generator.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o systemd-sslh-generator systemd-sslh-generator.o -lconfig
+
 echosrv: $(OBJS) echosrv.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o probe.o common.o $(LIBS)
+	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o probe.o common.o tls.o $(LIBS)
 
 $(MAN): sslh.pod Makefile
 	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)
@@ -68,8 +91,10 @@
 
 # generic install: install binary and man page
 install: sslh $(MAN)
-	install -pD sslh-fork $(DESTDIR)$(PREFIX)/sbin/sslh
-	install -pD -m 0644 $(MAN) $(DESTDIR)$(PREFIX)/share/man/man8/$(MAN)
+	mkdir -p $(DESTDIR)/$(BINDIR)
+	mkdir -p $(DESTDIR)/$(MANDIR)
+	install -p sslh-fork $(DESTDIR)/$(BINDIR)/sslh
+	install -p -m 0644 $(MAN) $(DESTDIR)/$(MANDIR)/$(MAN)
 
 # "extended" install for Debian: install startup script
 install-debian: install sslh $(MAN)
@@ -78,14 +103,14 @@
 	update-rc.d sslh defaults
 
 uninstall:
-	rm -f $(DESTDIR)$(PREFIX)/sbin/sslh $(DESTDIR)$(PREFIX)/share/man/man8/$(MAN) $(DESTDIR)/etc/init.d/sslh $(DESTDIR)/etc/default/sslh
+	rm -f $(DESTDIR)$(BINDIR)/sslh $(DESTDIR)$(MANDIR)/$(MAN) $(DESTDIR)/etc/init.d/sslh $(DESTDIR)/etc/default/sslh
 	update-rc.d sslh remove
 
 distclean: clean
 	rm -f tags cscope.*
 
 clean:
-	rm -f sslh-fork sslh-select echosrv version.h $(MAN) *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info
+	rm -f sslh-fork sslh-select echosrv version.h $(MAN) systemd-sslh-generator *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info
 
 tags:
 	ctags --globals -T *.[ch]
@@ -96,4 +121,3 @@
 
 test:
 	./t
-

=== debian/changelog ===
sslh (1.18-1) unstable; urgency=medium

  * New upstream release, include transparent mode local patch from upstream
    (Closes: #823229)
  * Bump to Standards-Version 3.9.8 (no changes needed)
  * Change Vcs-{Browser,Git} to use https instead of http/git
  * Set Documentation key to sslh(8) for systemd unit file

 -- Guillaume Delacour <gui@iroqwa.org>  Tue, 17 May 2016 20:56:14 +0200

=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Build-Depends: debhelper (>= 9.0.0), libwrap0-dev, binutils, po-debconf,
                libio-socket-inet6-perl, libconfig-dev, libcap-dev [linux-any],
                psmisc, lcov, dh-systemd (>= 1.5)
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://www.rutschle.net/tech/sslh.shtml
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/sslh.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/sslh.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/sslh.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/sslh.git
 
 Package: sslh
 Architecture: any

=== debian/watch ===
version=3
opts=uversionmangle=s/_/./g;s/^(\S*\.cyg-(?:i686|x86.64)-libconfig)$/0.0.$1/ \
http://www.rutschle.net/tech/sslh.shtml \
(?:|.*/)sslh(?:[_\-]v?|)(\d\S*)\.(?:tar\.xz|txz|tar\.bz2|tbz2|tar\.gz|tgz)

## sslh 1.20

=== Makefile ===
--- 
+++ 
@@ -3,7 +3,7 @@
 VERSION=$(shell ./genver.sh -r)
 ENABLE_REGEX=1  # Enable regex probes
 USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
-USELIBPCRE=	# Use libpcre? (needed for regex on musl)
+USELIBPCRE=1	# Use libpcre? (needed for regex on musl)
 USELIBWRAP?=	# Use libwrap?
 USELIBCAP=	# Use libcap?
 USESYSTEMD=     # Make use of systemd socket activation
@@ -27,6 +27,8 @@
 LIBS=
 OBJS=common.o sslh-main.o probe.o tls.o
 
+CONDITIONAL_TARGETS=
+
 ifneq ($(strip $(USELIBWRAP)),)
 	LIBS:=$(LIBS) -lwrap
 	CPPFLAGS+=-DLIBWRAP
@@ -38,7 +40,7 @@
 
 ifneq ($(strip $(USELIBPCRE)),)
 	CPPFLAGS+=-DLIBPCRE
-	LIBS:=$(LIBS) -lpcre
+	LIBS:=$(LIBS) -lpcreposix
 endif
 
 ifneq ($(strip $(USELIBCONFIG)),)
@@ -54,18 +56,21 @@
 ifneq ($(strip $(USESYSTEMD)),)
         LIBS:=$(LIBS) -lsystemd
         CPPFLAGS+=-DSYSTEMD
+	CONDITIONAL_TARGETS+=systemd-sslh-generator
 endif
 
 
-all: sslh $(MAN) echosrv
+all: sslh $(MAN) echosrv $(CONDITIONAL_TARGETS)
 
-.c.o: *.h
+.c.o: *.h version.h
 	$(CC) $(CFLAGS) $(CPPFLAGS) -c $<
 
 version.h:
 	./genver.sh >version.h
 
 sslh: sslh-fork sslh-select
+
+$(OBJS): version.h
 
 sslh-fork: version.h $(OBJS) sslh-fork.o Makefile common.h
 	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-fork sslh-fork.o $(OBJS) $(LIBS)
@@ -78,7 +83,7 @@
 systemd-sslh-generator: systemd-sslh-generator.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o systemd-sslh-generator systemd-sslh-generator.o -lconfig
 
-echosrv: $(OBJS) echosrv.o
+echosrv: version.h $(OBJS) echosrv.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o probe.o common.o tls.o $(LIBS)
 
 $(MAN): sslh.pod Makefile

=== debian/changelog ===
sslh (1.20-1) unstable; urgency=medium

  [ Guillaume Delacour ]
  * Remove debian/patches/transparent_mode_local.diff (merged upstream)
  * Replace extra priority by optional
  * Use debhelper 12 to avoid build depends on dh-systemd
  * Update obsolete homepage (Closes: #889575)

  [ Don Armstrong ]
  * New upstream release (Closes: #889576)
  * Refresh static port patch and remove localhost connection patch (for
    testing only)
  * Add patch which avoids requiring Conf::Libconfig, use dynamic ports
  * Bump to Standards-Version 4.4.0; primary change is
    --no-enable/--no-start instead of RUN

 -- Don Armstrong <don@debian.org>  Thu, 05 Sep 2019 10:04:54 -0700

=== debian/rules ===
--- 
+++ 
@@ -20,7 +20,7 @@
 
 # do not start daemon by default: force user to configure
 override_dh_installinit:
-	dh_installinit --no-start
+	dh_installinit --no-start --no-enable
 
 %:
-	dh $@ --with systemd
+	dh $@

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/sslh-$1\.tar\.gz/ \
  https://github.com/yrutschle/sslh/tags .*/v?(\d\S+)\.tar\.gz

## sslh 1.22c

=== Makefile ===
--- 
+++ 
@@ -1,12 +1,14 @@
-# Configuration
 
 VERSION=$(shell ./genver.sh -r)
+
+# Configuration -- you probably need to `make clean` if you
+# change any of these
 ENABLE_REGEX=1  # Enable regex probes
 USELIBCONFIG=1	# Use libconfig? (necessary to use configuration files)
-USELIBPCRE=1	# Use libpcre? (needed for regex on musl)
 USELIBWRAP?=	# Use libwrap?
 USELIBCAP=	# Use libcap?
 USESYSTEMD=     # Make use of systemd socket activation
+USELIBBSD?=     # Use libbsd (needed to update process name in `ps`)
 COV_TEST= 	# Perform test coverage?
 PREFIX?=/usr
 BINDIR?=$(PREFIX)/sbin
@@ -22,10 +24,10 @@
 endif
 
 CC ?= gcc
-CFLAGS ?=-Wall -g $(CFLAGS_COV)
+CFLAGS ?=-Wall -DLIBPCRE -g $(CFLAGS_COV)
 
-LIBS=
-OBJS=common.o sslh-main.o probe.o tls.o
+LIBS=-lm -lpcre2-8
+OBJS=sslh-conf.o common.o sslh-main.o probe.o tls.o argtable3.o udp-listener.o collection.o gap.o
 
 CONDITIONAL_TARGETS=
 
@@ -36,11 +38,6 @@
 
 ifneq ($(strip $(ENABLE_REGEX)),)
 	CPPFLAGS+=-DENABLE_REGEX
-endif
-
-ifneq ($(strip $(USELIBPCRE)),)
-	CPPFLAGS+=-DLIBPCRE
-	LIBS:=$(LIBS) -lpcreposix
 endif
 
 ifneq ($(strip $(USELIBCONFIG)),)
@@ -59,6 +56,11 @@
 	CONDITIONAL_TARGETS+=systemd-sslh-generator
 endif
 
+ifneq ($(strip $(USELIBBSD)),)
+        LIBS:=$(LIBS) -lbsd
+        CPPFLAGS+=-DLIBBSD
+endif
+
 
 all: sslh $(MAN) echosrv $(CONDITIONAL_TARGETS)
 
@@ -70,21 +72,27 @@
 
 sslh: sslh-fork sslh-select
 
-$(OBJS): version.h
+$(OBJS): version.h common.h collection.h sslh-conf.h gap.h
 
-sslh-fork: version.h $(OBJS) sslh-fork.o Makefile common.h
+sslh-conf.c sslh-conf.h: sslhconf.cfg
+	conf2struct sslhconf.cfg
+
+sslh-fork: version.h $(OBJS) sslh-fork.o Makefile
 	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-fork sslh-fork.o $(OBJS) $(LIBS)
 	#strip sslh-fork
 
-sslh-select: version.h $(OBJS) sslh-select.o Makefile common.h
+sslh-select: version.h $(OBJS) sslh-select.o Makefile
 	$(CC) $(CFLAGS) $(LDFLAGS) -o sslh-select sslh-select.o $(OBJS) $(LIBS)
 	#strip sslh-select
 
 systemd-sslh-generator: systemd-sslh-generator.o
 	$(CC) $(CFLAGS) $(LDFLAGS) -o systemd-sslh-generator systemd-sslh-generator.o -lconfig
 
-echosrv: version.h $(OBJS) echosrv.o
-	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o probe.o common.o tls.o $(LIBS)
+echosrv-conf.c echosrv-conf.h: echosrv.cfg
+	conf2struct echosrv.cfg
+
+echosrv: version.h echosrv-conf.c echosrv.o echosrv-conf.o argtable3.o
+	$(CC) $(CFLAGS) $(LDFLAGS) -o echosrv echosrv.o echosrv-conf.o argtable3.o $(LIBS)
 
 $(MAN): sslh.pod Makefile
 	pod2man --section=8 --release=$(VERSION) --center=" " sslh.pod | gzip -9 - > $(MAN)
@@ -93,6 +101,16 @@
 # configuration
 release:
 	git archive master --prefix="sslh-$(VERSION)/" | gzip > /tmp/sslh-$(VERSION).tar.gz
+	gpg --detach-sign --armor /tmp/sslh-$(VERSION).tar.gz
+
+# Build docker image
+docker:
+	docker image build -t "sslh:${VERSION}" .
+	docker image tag "sslh:${VERSION}" sslh:latest
+
+docker-clean:
+	yes | docker image rm "sslh:${VERSION}" sslh:latest
+	yes | docker image prune
 
 # generic install: install binary and man page
 install: sslh $(MAN)
@@ -112,7 +130,7 @@
 	update-rc.d sslh remove
 
 distclean: clean
-	rm -f tags cscope.*
+	rm -f tags sslh-conf.[ch] echosrv-conf.[ch] cscope.*
 
 clean:
 	rm -f sslh-fork sslh-select echosrv version.h $(MAN) systemd-sslh-generator *.o *.gcov *.gcno *.gcda *.png *.html *.css *.info

=== debian/changelog ===
sslh (1.22c-1) unstable; urgency=medium

  * New upstream release
  * Move --pidfile out of /etc/default/sslh to /etc/init.d/sslh to avoid
    issues with hardening options in systemd.
  * Switch to pcre2 (Closes: #999953)
  * Fix test failures due to Debian-only patch to avoid Conf::Libconfig.

 -- Don Armstrong <don@debian.org>  Tue, 15 Aug 2023 16:38:35 -0700

=== debian/control ===
Source: sslh
Section: net
Priority: optional
Maintainer: Don Armstrong <don@debian.org>
Build-Depends: debhelper-compat (= 12), libwrap0-dev, binutils, po-debconf,
               libio-socket-inet6-perl, libconfig-dev, libcap-dev [linux-any],
               psmisc, lcov, libpcre2-dev,
               init-system-helpers (>= 1.51)
Standards-Version: 4.4.0
Homepage: http://www.rutschle.net/tech/sslh/README.html
Vcs-Browser: https://salsa.debian.org/debian/sslh.git
Vcs-Git: https://salsa.debian.org/debian/sslh.git

Package: sslh
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, debconf (>= 0.5),
         update-inetd
Recommends: apache2 | httpd, openssh-server | ssh-server
Suggests: openbsd-inetd | inet-superserver
Conflicts: libnet-proxy-perl
Description: Applicative protocol multiplexer
 sslh lets one accept HTTPS, SSH, OpenVPN, tinc and XMPP connections on the
 same port. This makes it possible to connect to any of these servers on
 port 443 (e.g. from inside a corporate firewall, which almost never block
 port 443) while still serving HTTPS on that port.

## sslh 2.1.1

=== debian/changelog ===
sslh (2.1.1-2) unstable; urgency=low

  * Avoid blocking when reading data (Closes: #1082555)

 -- Don Armstrong <don@debian.org>  Sat, 21 Sep 2024 22:50:30 -0700

sslh (2.1.1-1) unstable; urgency=low

  * New upstream release
    - Addresses FTBFS (Closes: #1069381)
  * Add missing autoconf template for HAVELANDLOCK

 -- Don Armstrong <don@debian.org>  Thu, 25 Apr 2024 20:16:44 -0700

## sslh 2.1.4

=== hashtest/Makefile ===

CFLAGS=-DHASH_TESTING -O2 -Wall
OBJ=../hash.o ../gap.o htest.o

htest: $(OBJ)
	$(CC) -o htest $(OBJ)

=== debian/changelog ===
sslh (2.1.4-1) unstable; urgency=medium

  * New upstream release.
  * Enable systemd socket support

 -- Don Armstrong <don@debian.org>  Sun, 05 Jan 2025 10:59:07 -0800

sslh (2.1.2-1) unstable; urgency=medium

  * New upstream release.

 -- Don Armstrong <don@debian.org>  Wed, 02 Oct 2024 22:23:43 -0700

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,8 @@
 Maintainer: Don Armstrong <don@debian.org>
 Build-Depends: debhelper-compat (= 12), libwrap0-dev, binutils, po-debconf,
                libio-socket-inet6-perl, libconfig-dev, libcap-dev [linux-any],
-               psmisc, lcov, libpcre2-dev,
+               psmisc, lcov, libpcre2-dev, libev-dev, libsystemd-dev, libbsd-dev,
+               libcapture-tiny-perl, libdatetime-perl, libtimedate-perl,
                init-system-helpers (>= 1.51)
 Standards-Version: 4.4.0
 Homepage: http://www.rutschle.net/tech/sslh/README.html

=== debian/rules ===
--- 
+++ 
@@ -6,7 +6,7 @@
 
 DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
 ifeq ($(DEB_HOST_ARCH_OS),linux)
-	EXTRA_OPTIONS := USELIBCAP=1
+	EXTRA_OPTIONS := USELIBCAP=1 USESYSTEMD=1
 else
 	EXTRA_OPTIONS :=
 endif
